// miniprogram/pages/userAuth.js
var app = getApp();
var mqtt = require('../../js/mqtt.js');

Page({

  /**
   * 页面的初始数据
   */
  data: {
      topic: '',
      log:''
  },

  onLoad: function (options) {
    var self = this;
    self.setData({
      topic: '$oc/devices/' + app.globalData.deviceId + '/commands/#'
      });
  },

  getTopic(e) {
    this.setData({
      topic:  e.detail.value
    })
  },

  //事件处理函数
  subscribe: function (e){
    self = this;
    const client = app.globalData.client;
    console.log(app.globalData.deviceId);
    if (client == null || client.connected == false) {
      log('device is not connect to platform');
      return;
    }
    log('subscribe topic:' + self.data.topic);
    client.subscribe(self.data.topic, {qos: 1},  function(err, granted){
      if (!err) {
        log('subscribe message successful');
      } 
    });

    client.on('message', (topic, message, packet) => {
      log('receive message topic:' + topic);
      log('receive message content:' + message.toString());
      //收到命令下发请求时，返回命令的响应
      sendResponse(topic.split("=")[1]);
    });

    function sendResponse(requestId) {
      let responseReqJson = {
          result_code: 0,
          response_name: 'COMMAND_RESPONSE',
          paras: {result: 'success'}
      };
      let responseReq = JSON.stringify(responseReqJson);
      log('response topic is ' + getResponseTopic(requestId));
      log('response message is ' + responseReq);
      client.publish(getResponseTopic(requestId), responseReq);
  }
  function getResponseTopic(requestId) {
      return (
          '$oc/devices/' +
          app.globalData.deviceId +
          '/sys/commands/response/request_id=' +
          requestId
      );
  }

  function log(msg) {
      console.log(new Date() + ' - ' + msg
      );
      self.data.log = self.data.log + new Date() + ' - ' + msg + '\r\n';
      self.setData({
        log: self.data.log
      })
  }
}

})